/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "StdAfx.h"
#include "CDlgAbout.h"
#include "Resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


CDlgAbout::CDlgAbout(void) : EDialog (MAKEINTRESOURCE (IDD))
{
}

CDlgAbout::~CDlgAbout(void)
{
}

BOOL CDlgAbout::OnInitDialog ()
{
	LPVOID				pVerInfo	= NULL;
	VS_FIXEDFILEINFO*	pFixedInfo	= NULL;
	PUSHORT				pLangCode	= NULL;
	ULONG				dwHandle;
	ULONG				dwSize;
	UINT				dwFixedInfoSize;
	TCHAR				szFilename[MAX_PATH] = {0};
	UINT				Length;
	TCHAR				szVersion[512] = {0};
	TCHAR				szProductName[512] = {0};
	TCHAR				szLegalCopyright[512] = {0};
	TCHAR				szInfo[512] = {0};
	LPTSTR				pString;

	do
	{
		::GetModuleFileName (NULL, szFilename, MAX_PATH);
	
		dwSize = ::GetFileVersionInfoSize (szFilename, &dwHandle);
	
		if (dwSize == 0)
		{	break;
		}

		pVerInfo =(LPVOID)new UCHAR[dwSize];
		if (pVerInfo == NULL)
		{	return FALSE;
		}
			
		if (!::GetFileVersionInfo (szFilename, dwHandle, dwSize, pVerInfo))
		{	break;
		}

		if (!::VerQueryValue (pVerInfo, _T("\\"), (LPVOID*)&pFixedInfo, &dwFixedInfoSize))
		{	break;
		}
		
		if (::VerQueryValue (pVerInfo, _T("\\VarFileInfo\\Translation"), (LPVOID *)&pLangCode, &Length))
		{
			StringCchPrintf (szInfo, _countof (szInfo), _T("\\StringFileInfo\\%04x%04x\\ProductName"), pLangCode[0], pLangCode[1]);
			if (::VerQueryValue( pVerInfo, szInfo, (LPVOID *)&pString, &Length))
			{	
#ifdef _UNICODE
				StringCchPrintf (szProductName, min (_countof (szProductName), Length), _T("%s"), pString);
#else
				StringCchPrintf (szProductName, min (_countof (szProductName), Length), _T("%S"), pString);
#endif
			}

			StringCchPrintf (szInfo, _countof (szInfo), _T("\\StringFileInfo\\%04x%04x\\LegalCopyright"), pLangCode[0], pLangCode[1]);
			if (::VerQueryValue( pVerInfo, szInfo, (LPVOID *)&pString, &Length))
			{
#ifdef _UNICODE
				StringCchPrintf (szLegalCopyright, min (_countof (szLegalCopyright), Length), _T("%s"), pString);
#else
				StringCchPrintf (szLegalCopyright, min (_countof (szLegalCopyright), Length), _T("%S"), pString);
#endif
			}
		}
	}
	while (0);


	StringCchPrintf (szVersion, _countof (szVersion), _T("%s Ver %u.%02u.%04u.%04u"), szProductName, HIWORD(pFixedInfo->dwFileVersionMS), LOWORD(pFixedInfo->dwFileVersionMS), HIWORD(pFixedInfo->dwFileVersionLS), LOWORD(pFixedInfo->dwFileVersionLS));
	if (pVerInfo != NULL)
	{	delete pVerInfo;
	}

	::SetDlgItemText (m_hWnd, IDC_VERSION_LABEL, szVersion);
	::SetDlgItemText (m_hWnd, IDC_COPYRIGHT_LABEL, szLegalCopyright);


	return TRUE;
}
