/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#pragma once

#ifdef _DEBUG_MEMORY

void* __cdecl operator new(size_t Size, LPCSTR pszFileName, int Line);
void* __cdecl operator new[](size_t Size, LPCSTR pszFileName, int Line);
void* __cdecl operator new(size_t Size);

void __cdecl operator delete(void* p, LPCSTR pszFileName, int Line);
void __cdecl operator delete[](void* p, LPCSTR pszFileName, int Line);
void __cdecl operator delete(void* p);

void DebugMemoryDump ();

#define DEBUG_NEW new(__FILE__, __LINE__)

#define DEBUG_MEMORY_DUMP DebugMemoryDump()


#else

#define DEBUG_MEMORY_DUMP 


#endif

#ifdef _DEBUG

#ifndef DEBUG_NEW
#define DEBUG_NEW new
#endif

#define DEBUG_ONLY(f)      f
#else
#define DEBUG_ONLY(f)      ((void)0)
#endif



void AssertFailedLine (LPCSTR pszFile, ULONG Line, LPCSTR pszExpr);
void DbgMsg (LPCSTR pszFormat, ...);

#define ASSERT(f)			DEBUG_ONLY( if (!(f)) {	AssertFailedLine(__FILE__, __LINE__, #f);	__debugbreak ();})
#define DBG_MSG(_msg_)		DEBUG_ONLY( DbgMsg##_msg_;)