/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "StdAfx.h"
#include "EEditListCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



EEditListCtrl::EEdit::EEdit (HWND hParent, INT Index, INT Column, LPCTSTR pString, TCHAR Char, RECT* pRect)
{
	TCHAR	szText[2] = {Char, 0};
	
	m_Index		= Index;;
	m_Column	= Column;

	if (Char != 0)
	{
		pString = szText;
	}

	CreateEx (0, WC_EDIT, pString, WS_CHILDWINDOW | WS_VISIBLE | WS_BORDER | ES_AUTOHSCROLL , pRect->left, pRect->top, pRect->right- pRect->left, pRect->bottom - pRect->top, hParent, 0);
	::SendMessage (m_hWnd, WM_SETFONT, (WPARAM)::SendMessage(hParent, WM_GETFONT, 0, 0), 0);
	::SetFocus(m_hWnd);

	if (Char == 0)
	{
		::SendMessage(m_hWnd, EM_SETSEL, 0, -1);
	}
	else
	{
		::SendMessage(m_hWnd, EM_SETSEL, 1, 1);
	}

	::SetCapture (m_hWnd);
}



BOOL EEditListCtrl::EEdit::OnWndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	switch (message)
	{
	case WM_KILLFOCUS:
		{
			LPTSTR			pszText		= NULL;
			INT				Length		= 0;
			NMLVDISPINFO	Info		= {0};

			Length = ::GetWindowTextLength (m_hWnd) + 1;

			pszText = new TCHAR[Length];
			if (pszText != NULL)
			{
				::GetWindowText (m_hWnd, pszText, Length);
			}

			EEditListCtrl::EndLabelEdit (::GetParent (m_hWnd), m_Index, m_Column, pszText);

			if (pszText != NULL)
			{
				delete pszText;
			}

			::PostMessage (m_hWnd, EWindow::WM_DELETE_THIS, 0, 0);
		}
		break;

	case WM_CHAR:
		{
			switch (wParam)
			{
			case VK_RETURN:
			case VK_ESCAPE:
				{
					::SetFocus (::GetParent (m_hWnd));
					return TRUE;
				}
				break;
			}
		}
		break;

	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
		{
			POINTS	Point = MAKEPOINTS (lParam);
			RECT	Rect = {0};

			::GetClientRect (m_hWnd, &Rect);

			if ((Point.x < Rect.left) || (Point.x > Rect.right) || (Point.y > Rect.bottom) || (Point.y < Rect.top))
			{
				::SetFocus (::GetParent (m_hWnd));
				return TRUE;
			}

		}
		break;

	case WM_DESTROY:
		{
			::ReleaseCapture ();
		}
		break;
	}

	return FALSE;
}
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/

EEditListCtrl::EComboBox::EComboBox (HWND hParent, INT Index, INT Column, EStringArray* pArray, LPCTSTR pString, RECT* pRect)
{
	m_Index		= Index;;
	m_Column	= Column;

	CreateEx (0, WC_COMBOBOX, NULL, WS_CHILDWINDOW | WS_VISIBLE | CBS_DROPDOWNLIST , pRect->left, pRect->top, pRect->right- pRect->left, pRect->bottom - pRect->top + 200, hParent, 0);
	::SendMessage (m_hWnd, WM_SETFONT, (WPARAM)::SendMessage(hParent, WM_GETFONT, 0, 0), 0);
	::SetFocus(m_hWnd);

	for (int i=0;i<pArray->GetCount ();i++)
	{
		::SendMessage (m_hWnd, CB_ADDSTRING, 0, (LPARAM)pArray->GetAt (i));
		if (lstrcmp (pArray->GetAt (i), pString) == 0)
		{	::SendMessage (m_hWnd, CB_SETCURSEL, i, 0); 
		}
	}

	::SetCapture (m_hWnd);

	::SendMessage (m_hWnd, CB_SHOWDROPDOWN, TRUE, 0);
	
}



BOOL EEditListCtrl::EComboBox::OnWndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	switch (message)
	{
	case WM_KILLFOCUS:
		{
			LPTSTR			pszText		= NULL;
			INT				Length		= 0;
			NMLVDISPINFO	Info		= {0};

			Length = ::GetWindowTextLength (m_hWnd) + 1;

			pszText = new TCHAR[Length];
			if (pszText != NULL)
			{
				::GetWindowText (m_hWnd, pszText, Length);
			}

			EEditListCtrl::EndLabelEdit (::GetParent (m_hWnd), m_Index, m_Column, pszText);

			if (pszText != NULL)
			{
				delete pszText;
			}

			::PostMessage (m_hWnd, EWindow::WM_DELETE_THIS, 0, 0);
		}
		break;

	case WM_CHAR:
		{
			switch (wParam)
			{
			case VK_RETURN:
			case VK_ESCAPE:
				{
					::SetFocus (::GetParent (m_hWnd));
					return TRUE;
				}
				break;
			}
		}
		break;

	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
		{
			POINTS	Point = MAKEPOINTS (lParam);
			RECT	Rect = {0};

			::GetClientRect (m_hWnd, &Rect);

			if ((Point.x < Rect.left) || (Point.x > Rect.right) || (Point.y > Rect.bottom) || (Point.y < Rect.top))
			{
				::SetFocus (::GetParent (m_hWnd));
				return TRUE;
			}

		}
		break;

	case WM_DESTROY:
		{
			::ReleaseCapture ();
		}
		break;

	case WM_COMMAND + WM_REFLECT_BASE:
		{
			switch (HIWORD(wParam))
			{
			case CBN_DROPDOWN:
				{
					::ReleaseCapture ();
				}
				break;

			case CBN_CLOSEUP:
				{
					::SetCapture (m_hWnd);
				}
				break;
			}

		}
		break;


	}

	return FALSE;
}















//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
//-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
///-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/

EEditListCtrl::EEditListCtrl(void)
{
	m_SelectedColumn = -1;
}

EEditListCtrl::~EEditListCtrl(void)
{
}

BOOL EEditListCtrl::OnWndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	BOOL RetCode = FALSE;

	//DBG_MSG(("%08X, hWnd=%08X, message=%08X, wParam=%08X, lParam=%08X \n", GetTickCount (), hWnd, message, wParam, lParam));
	switch (message)
	{
	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
		{
			LVHITTESTINFO	lvhti		= {0};
			POINTS			Points		= MAKEPOINTS (lParam);
			INT				PrevColumn	= m_SelectedColumn;

			lvhti.pt.x = Points.x;
			lvhti.pt.y = Points.y;

			ListView_SubItemHitTest (hWnd, &lvhti);

			m_SelectedColumn = lvhti.iSubItem;
			if (m_SelectedColumn != -1)
			{	RedrawItems (m_SelectedColumn, m_SelectedColumn);
			}

			if (PrevColumn != -1)
			{	RedrawItems (PrevColumn, PrevColumn);
			}
		}
		break;

	case WM_CHAR:
		{
			if ((wParam >= ' ') && (wParam <= 'z'))
			{
				NMLVDISPINFO DispInfo = {0};

				DispInfo.hdr.code		= LVN_BEGINLABELEDIT;
				DispInfo.hdr.hwndFrom	= m_hWnd;
				DispInfo.hdr.idFrom		= ::GetDlgCtrlID (m_hWnd);
				DispInfo.item.mask		= 0;
				DispInfo.item.iItem		= (INT)::SendMessage(m_hWnd, LVM_GETNEXTITEM, -1, MAKELPARAM(LVIS_SELECTED, 0));
				DispInfo.item.iSubItem	= m_SelectedColumn;
				
				return BeginLabelEdit (&DispInfo, (TCHAR)wParam);
			}

		}
		break;

	case WM_KEYDOWN:
		{
			HWND hHdr = ListView_GetHeader (m_hWnd);
			INT Count = 0;

			if (hHdr == NULL)
			{	break;
			}

			Count = Header_GetItemCount (hHdr);

			switch (wParam)
			{
			case VK_LEFT:
				{
					m_SelectedColumn--;
					if (m_SelectedColumn < 0)
					{	
						m_SelectedColumn = Count - 1;
					}

					RedrawItems (m_SelectedColumn, m_SelectedColumn);
				}
				break;

			case VK_RIGHT:
				{
					m_SelectedColumn++;
					if (m_SelectedColumn >= Count)
					{	
						m_SelectedColumn = 0;
					}
					RedrawItems (m_SelectedColumn, m_SelectedColumn);
				}
				break;
			}
		}
		break;

	}

	return RetCode;
}


BOOL EEditListCtrl::OnNotifyRefrection (WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	NMLISTVIEW*		pNmListView		= (NMLISTVIEW*)lParam;
	BOOL			RetCode			= FALSE;
	NMLVDISPINFO	DispInfo		= {0};

	switch (pNmListView->hdr.code)
	{
	case NM_DBLCLK:
		{
			RECT			Rect		= {0};

			if (::GetWindowLong (m_hWnd, GWL_STYLE) & LVS_EDITLABELS)
			{	break;
			}

			DispInfo.hdr.code		= LVN_BEGINLABELEDIT;
			DispInfo.hdr.hwndFrom	= m_hWnd;
			DispInfo.hdr.idFrom		= ::GetDlgCtrlID (m_hWnd);
			DispInfo.item.iItem		= pNmListView->iItem;
			DispInfo.item.iSubItem	= pNmListView->iSubItem;
			DispInfo.item.pszText	= NULL;
			DispInfo.item.mask		= 0;

			return (BOOL)::SendMessage (::GetParent (m_hWnd), WM_NOTIFY, DispInfo.hdr.idFrom, (WPARAM)&DispInfo);
		}
		break;

	case NM_CLICK:
		{
		}
		break;



	case NM_RETURN:
		{
			DispInfo.hdr.code		= LVN_BEGINLABELEDIT;
			DispInfo.hdr.hwndFrom	= m_hWnd;
			DispInfo.hdr.idFrom		= ::GetDlgCtrlID (m_hWnd);
			DispInfo.item.mask		= 0;
			DispInfo.item.iItem		= (INT)::SendMessage(m_hWnd, LVM_GETNEXTITEM, -1, MAKELPARAM(LVIS_SELECTED, 0));
			DispInfo.item.iSubItem	= m_SelectedColumn;
			
			return (BOOL)::SendMessage (::GetParent (m_hWnd), WM_NOTIFY, (WPARAM)DispInfo.hdr.idFrom, (LPARAM)&DispInfo);
		}
		break;

	case LVN_ITEMCHANGED:
		{
			DBG_MSG(("EEditListCtrl::OnNotifyRefrection - LVN_ITEMCHANGED, iItem=%d, iSubItem=%d, uChanged=%08X, uNewState=%08X, uOldState=%08X \n", pNmListView->iItem, pNmListView->iSubItem, pNmListView->uChanged, pNmListView->uNewState, pNmListView->uOldState));
		}
		break;

	case LVN_GETDISPINFOW:
		{
			DBG_MSG(("EEditListCtrl::OnNotifyRefrection - LVN_GETDISPINFOW, iItem=%d, iSubItem=%d, uChanged=%08X, uNewState=%08X, uOldState=%08X \n", pNmListView->iItem, pNmListView->iSubItem, pNmListView->uChanged, pNmListView->uNewState, pNmListView->uOldState));
		}
		break;

	case LVN_BEGINLABELEDIT:
		{
			return BeginLabelEdit ((NMLVDISPINFO*)lParam, 0);
		}
		break;

	case LVN_ENDLABELEDIT:
		{
			return OnEndLabelEdit ((NMLVDISPINFO*)lParam);
		}
		break;

	default:
		{
			DBG_MSG(("EEditListCtrl::OnNotifyRefrection - wParam=%08X, code=%08X, hwndFrom=%08X, idFrom=%08X \n"
				, wParam
				, pNmListView->hdr.code
				, pNmListView->hdr.hwndFrom
				, pNmListView->hdr.idFrom));
		}
		break;
	}

	
	return RetCode;
}

BOOL EEditListCtrl::BeginLabelEdit (NMLVDISPINFO* pInfo, TCHAR Char)
{
	NMLVDISPINFO	Info		= *pInfo;
	LPTSTR			pszText		= NULL;
	RECT			Rect		= {0};
	BOOL			RetCode		= FALSE;

	if ((pInfo->item.iItem == -1) || (pInfo->item.iSubItem == -1))
	{	return FALSE;
	}

	if ((pInfo->item.mask & LVIF_TEXT) == 0)
	{
		pszText = new TCHAR[LISTCTRL_MAX_TEXT_SIZE];
		GetItemText (pInfo->item.iItem, pInfo->item.iSubItem, pszText, LISTCTRL_MAX_TEXT_SIZE);
		Info.item.pszText = pszText;
	}

	ListView_GetSubItemRect (m_hWnd, pInfo->item.iItem, pInfo->item.iSubItem, LVIR_LABEL, &Rect);

	RetCode = OnBeginLabelEdit (&Info, Char, &Rect);

	if (pszText != NULL)
	{
		delete pszText;
	}

	return RetCode;
}

BOOL EEditListCtrl::OnBeginLabelEdit (NMLVDISPINFO* pInfo, TCHAR Char, RECT* pRect)
{

/*
	EStringArray Array;
	Array.Add (_T("TEST1"));
	Array.Add (_T("TEST2"));
	Array.Add (_T("TEST3"));
	Array.Add (_T("TEST4"));
	Array.Add (_T("TEST5"));
	Array.Add (_T("TEST6"));
	EComboBox* pCombo = new EComboBox (m_hWnd, pInfo->item.iItem, pInfo->item.iSubItem, &Array, pText, pRect);
*/
	EEdit* pEdit = new EEdit(m_hWnd, pInfo->item.iItem, pInfo->item.iSubItem, pInfo->item.pszText, Char, pRect);


	return TRUE;
}

BOOL EEditListCtrl::EndLabelEdit (HWND hWnd, INT Item, INT Column, LPCTSTR pszText)
{
	NMLVDISPINFO	DispInfo		= {0};

	DispInfo.hdr.code		= LVN_ENDLABELEDIT;
	DispInfo.hdr.hwndFrom	= hWnd;
	DispInfo.hdr.idFrom		= ::GetDlgCtrlID (hWnd);
	DispInfo.item.iItem		= Item;
	DispInfo.item.iSubItem	= Column;
	DispInfo.item.pszText	= (LPTSTR)pszText;
	DispInfo.item.mask		= LVIF_TEXT;

	return (BOOL)::SendMessage (::GetParent (hWnd), WM_NOTIFY, DispInfo.hdr.idFrom, (WPARAM)&DispInfo);
}

BOOL EEditListCtrl::OnEndLabelEdit (NMLVDISPINFO* pInfo)
{
	if (pInfo->item.mask & LVIF_TEXT)
	{
		SetItemText (pInfo->item.iItem, pInfo->item.iSubItem, pInfo->item.pszText);
	}

	return TRUE;
}


