/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "EIniFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


TCHAR	EIniFile::s_szIniFile[MAX_PATH];
INT		EIniFile::s_Initialized = EIniFile::Initialize ();

INT EIniFile::Initialize ()
{
	TCHAR		szIniFile[MAX_PATH] = {0};
	size_t		Length;

	::GetModuleFileName (NULL, szIniFile, _countof (szIniFile));
	
	StringCchLength (szIniFile, _countof (szIniFile), &Length);
	
	while (Length)
	{
		Length--;
		if (szIniFile[Length] == '.')
		{	szIniFile[Length] = 0;
			break;
		}
	}

	StringCchCat (szIniFile, _countof (szIniFile), _T(".ini"));
	SetIniFileName (szIniFile);

	return 1;
}

LPCTSTR EIniFile::GetIniFileName ()
{
	return s_szIniFile;
}

VOID EIniFile::SetIniFileName (LPCTSTR FileName)
{
	StringCchCopyN (s_szIniFile, _countof (s_szIniFile), FileName, STRSAFE_MAX_CCH);
}


//-------------------------------------------------------------------------------------------------
//	INI File
//-------------------------------------------------------------------------------------------------
BOOL EIniFile::SetValue(LPCTSTR Section, LPCTSTR ValueName, LPCTSTR Value)
{
	return ::WritePrivateProfileString (Section, ValueName, Value, s_szIniFile);
}

BOOL EIniFile::SetValue(LPCTSTR Section, LPCTSTR ValueName, ULONG Value)
{
	TCHAR szString[32] = {0};
	StringCchPrintf (szString, _countof (szString), _T("%u"), Value);
	return SetValue (Section, ValueName, szString);
}

BOOL EIniFile::SetValue (LPCTSTR Section, LPCTSTR ValueName, PUCHAR pBuffer, ULONG Length)
{
	return WritePrivateProfileStruct (Section, ValueName, pBuffer, Length, s_szIniFile);
}



BOOL EIniFile::GetValue(LPCTSTR Section, LPCTSTR ValueName, LPTSTR Value, ULONG nSize, LPCTSTR DefaultValue)
{
	return ::GetPrivateProfileString (Section, ValueName, DefaultValue, Value, nSize, s_szIniFile);
}

BOOL EIniFile::GetValue(LPCTSTR Section, LPCTSTR ValueName, PUCHAR pValue, ULONG nSize)
{
	return ::GetPrivateProfileStruct (Section, ValueName, pValue, nSize, s_szIniFile);
}

BOOL EIniFile::GetValue(LPCTSTR Section, LPCTSTR ValueName, PULONG Value, ULONG DefaultValue)
{
	TCHAR szDefault[32] = {0};
	TCHAR szValue[32] = {0};
	BOOL	RetCode;

	StringCchPrintf (szDefault, _countof (szDefault), _T("%u"), DefaultValue);

	RetCode = GetValue (Section, ValueName, szValue, _countof (szValue), szDefault);
	*Value = _ttol (szValue);

	return RetCode;
}

