/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "StdAfx.h"
#include "ELandeRd.h"
#include "Resource.h"
#include "CDlgAbout.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

DECLARE_WINMAIN (ELandeRd)

ELandeRd::ELandeRd(void)
{
}

ELandeRd::~ELandeRd(void)
{
}

BOOL ELandeRd::OnInitiInstance ()
{
	::LoadString (m_hInstance, IDS_APP_TITLE, m_szTitle, _countof (m_szTitle));
	StringCchCopy (m_szWindowClass, _countof (m_szWindowClass), _T("ELandeRd"));
	
	return TRUE;
}

VOID ELandeRd::OnExitInstance ()
{
}

BOOL ELandeRd::OnPreRegisterClass (WNDCLASSEX* pWndClass)
{
	pWndClass->hIcon		= ::LoadIcon (m_hInstance, MAKEINTRESOURCE(IDR_MAINFRAME));
	pWndClass->hIconSm		= ::LoadIcon (m_hInstance, MAKEINTRESOURCE(IDR_MAINFRAME));
	pWndClass->lpszMenuName	= MAKEINTRESOURCE(IDM_MENU);

	return TRUE;
}


BOOL ELandeRd::OnCommand (WPARAM wParam, LPARAM lParam)
{
	USHORT NotifyCode	= HIWORD(wParam);
	USHORT Id			= LOWORD(wParam);
	HWND hWndCtl		= (HWND)lParam;

	switch (Id)
	{
	case IDM_ABOUT:
		{
			OnCmdAbout ();
		}
		break;

	case IDM_EXIT:
		{
			::DestroyWindow (m_hWnd);
		}
		break;

	default:
		{
			return FALSE;
		}
		break;
	}

	return TRUE;
}

BOOL ELandeRd::OnNotify (WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	NMHDR* pNmHdr = (NMHDR*)lParam;
	BOOL		RetCode = FALSE;

	switch (pNmHdr->code)
	{
		case LVN_ENDLABELEDIT:
			{
				NMLVDISPINFO* pInfo = (NMLVDISPINFO*)lParam;

				if (pNmHdr->idFrom == IDC_OPTION_LISTCTRL)
				{
					switch (pInfo->item.iItem)
					{
					case EOptionListCtrl::INDEX_SAVE_FOLDER:
						{
							m_FtpServer.SetSaveFolder (pInfo->item.pszText);
						}
						break;

					case EOptionListCtrl::INDEX_ADD_TIME_DATE:
						{
							m_FtpServer.m_bAddTimeDate = (lstrcmp (pInfo->item.pszText, _T("Yes")) == 0);
						}
						break;

					case EOptionListCtrl::INDEX_MAKE_INFO_TXT:
						{
							m_FtpServer.m_bMakeInfoTxt = (lstrcmp (pInfo->item.pszText, _T("Yes")) == 0);
						}
						break;

					case EOptionListCtrl::INDEX_NETWORK_NAME:
						{
							m_WinPcap.SetName (ET2A (pInfo->item.pszText));
						}
						break;

					default:
						{
							ASSERT (FALSE);
						}
						break;
					}
				}
			}
			break;
	}

	return FALSE;
}

VOID ELandeRd::InsertColumn (EListCtrl* pListCtrl, INT Column, UINT nResId, ULONG Width)
{
	TCHAR	szText[1024] = {0};
	::LoadString (GetInstanceHandle (), nResId, szText, _countof (szText));
	pListCtrl->InsertColumn (Column, szText, LVCFMT_LEFT, Width);
}

BOOL ELandeRd::OnCreate (CREATESTRUCT* pStruct)
{
	RECT	Rect;
	TCHAR	szText[1024];

	::GetClientRect (m_hWnd, &Rect);

	if (!m_StatusListCtrl.Create (0, WS_CHILD | WS_VISIBLE | LVS_REPORT | LVS_NOSORTHEADER, 0, 0, Rect.right, Rect.bottom, m_hWnd, IDC_STATUS_LISTCTRL))
	{	return FALSE;
	}
	
	InsertColumn (&m_StatusListCtrl, STATUS_LIST_COLUMN_FILENAME		, IDS_STATUS_LIST_COLUMN_FILENAME		, 300);
	InsertColumn (&m_StatusListCtrl, STATUS_LIST_COLUMN_FILE_LENGTH		, IDS_STATUS_LIST_COLUMN_FILE_LENGTH	, 120);
	InsertColumn (&m_StatusListCtrl, STATUS_LIST_COLUMN_ELAPSED_TIME	, IDS_STATUS_LIST_COLUMN_ELAPSED_TIME	, 100);
	InsertColumn (&m_StatusListCtrl, STATUS_LIST_COLUMN_ELAPSED_PER		, IDS_STATUS_LIST_COLUMN_ELAPSED_PER	, 100);
	InsertColumn (&m_StatusListCtrl, STATUS_LIST_COLUMN_RECEIVE_RATE	, IDS_STATUS_LIST_COLUMN_RECEIVE_RATE	, 160);
	InsertColumn (&m_StatusListCtrl, STATUS_LIST_COLUMN_REMAIN_TIME		, IDS_STATUS_LIST_COLUMN_REMAIN_TIME	, 100);
	InsertColumn (&m_StatusListCtrl, STATUS_LIST_COLUMN_STATUS			, IDS_STATUS_LIST_COLUMN_STATUS			, 400);


	if (!m_OptionListCtrl.Create (0, WS_CHILD | WS_VISIBLE | LVS_REPORT | LVS_NOSORTHEADER, 0, 0, Rect.right, Rect.bottom, m_hWnd, IDC_OPTION_LISTCTRL))
	{	return FALSE;
	}

	InsertColumn (&m_OptionListCtrl, OPTION_LIST_COLUMN_NAME			, IDS_OPTION_LIST_COLUMN_NAME		, 180);
	InsertColumn (&m_OptionListCtrl, OPTION_LIST_COLUMN_VALUE			, IDS_OPTION_LIST_COLUMN_VALUE		, 500);

	while (m_OptionListCtrl.GetItemCount () < EOptionListCtrl::INDEX_MAX)
	{
		m_OptionListCtrl.InsertItem (LVIF_TEXT, 0, _T(""), 0, 0, 0, 0);
	}

	EUtility::LoadString (IDS_OPTION_LIST_INDEX_FOLDER, szText, _countof (szText));
	m_OptionListCtrl.SetItemText (EOptionListCtrl::INDEX_SAVE_FOLDER, 0, szText);

	EUtility::LoadString (IDS_OPTION_LIST_INDEX_ADD_TIME_DATE, szText, _countof (szText));
	m_OptionListCtrl.SetItemText (EOptionListCtrl::INDEX_ADD_TIME_DATE, 0, szText);

	EUtility::LoadString (IDS_OPTION_LIST_INDEX_MAKE_INFO_TXT, szText, _countof (szText));
	m_OptionListCtrl.SetItemText (EOptionListCtrl::INDEX_MAKE_INFO_TXT, 0, szText);

	EUtility::LoadString (IDS_OPTION_LIST_INDEX_NAME, szText, _countof (szText));
	m_OptionListCtrl.SetItemText (EOptionListCtrl::INDEX_NETWORK_NAME, 0, szText);

	LoadSetting ();

	if (!m_WinPcap.StartCapture ("dst port 137"))
	{
		EUtility::MsgBox (m_hWnd, IDS_APP_TITLE, IDS_WINPCAP_ERROR, MB_OK | MB_ICONSTOP);
	}

	m_FtpServer.SetCallBack (OnFtpCallBack, this);
	m_FtpServer.Start ();

	return TRUE;
}

VOID ELandeRd::OnDestroy ()
{
	SaveSetting ();

	m_WinPcap.StopCapture ();

	m_FtpServer.SetCallBack (NULL, NULL);
	m_FtpServer.Stop ();
}

VOID ELandeRd::LoadSetting ()
{
	TCHAR	szMyDir[MAX_PATH];
	TCHAR	szText[1024];
	ULONG	Value;
	LPCTSTR	pszYesNo[2] = {_T("No"), _T("Yes")};

	EUtility::GetMyDir (szMyDir, _countof (szMyDir));
	EIniFile::GetValue (_T("Option"), _T("SaveFolder"), szText, _countof (szText), szMyDir);
	m_OptionListCtrl.SetItemText (EOptionListCtrl::INDEX_SAVE_FOLDER, 1, szText);
	m_FtpServer.SetSaveFolder (szText);
	
	EIniFile::GetValue (_T("Option"), _T("AddTimeDate"), &Value, 0);
	m_FtpServer.m_bAddTimeDate = (Value != 0);
	m_OptionListCtrl.SetItemText (EOptionListCtrl::INDEX_ADD_TIME_DATE, 1, pszYesNo[m_FtpServer.m_bAddTimeDate]);

	EIniFile::GetValue (_T("Option"), _T("MakeInfoTxt"), &Value, 0);
	m_FtpServer.m_bMakeInfoTxt = (Value != 0);
	m_OptionListCtrl.SetItemText (EOptionListCtrl::INDEX_MAKE_INFO_TXT, 1, pszYesNo[m_FtpServer.m_bMakeInfoTxt]);

	EIniFile::GetValue (_T("Option"), _T("NetworkName"), szText, _countof (szText), _T("LandeRD"));
	m_WinPcap.SetName (ET2A (szText));
	m_OptionListCtrl.SetItemText (EOptionListCtrl::INDEX_NETWORK_NAME, 1, szText);

}

VOID ELandeRd::SaveSetting ()
{
	EIniFile::SetValue (_T("Option"), _T("SaveFolder"), m_FtpServer.GetSaveFolder ());
	EIniFile::SetValue (_T("Option"), _T("AddTimeDate"), m_FtpServer.m_bAddTimeDate);
	EIniFile::SetValue (_T("Option"), _T("MakeInfoTxt"), m_FtpServer.m_bMakeInfoTxt);
	EIniFile::SetValue (_T("Option"), _T("NetworkName"), EA2T(m_WinPcap.GetName ()));



}

VOID ELandeRd::OnSize (UINT nType, int cx, int cy)
{
	if ((::IsWindow (m_StatusListCtrl.m_hWnd)) &&  (::IsWindow (m_OptionListCtrl.m_hWnd)))
	{	
		int Height;
		RECT Rect = {0};
		
		ListView_GetItemRect (m_OptionListCtrl.m_hWnd, 0, &Rect, LVIR_BOUNDS);
		Height = (Rect.bottom - Rect.top) * (m_OptionListCtrl.GetItemCount () + 1) + 20;

		::SetWindowPos (m_OptionListCtrl.m_hWnd, NULL, 0, 0, cx, Height, SWP_NOZORDER | SWP_NOACTIVATE | SWP_NOOWNERZORDER);
		::SetWindowPos (m_StatusListCtrl.m_hWnd, NULL, 0, Height, cx, cy, SWP_NOZORDER | SWP_NOACTIVATE | SWP_NOOWNERZORDER);
	}
}



VOID ELandeRd::OnCmdAbout ()
{
	CDlgAbout Dlg;

	Dlg.DoModal (m_hWnd);
}


VOID ELandeRd::OnFtpCallBack (ULONG Type, PVOID pData, PVOID pContext)
{
	ERdFtpServer::ERdData*	pRdData			= (ERdFtpServer::ERdData*)pData;
	ELandeRd*				pThis			= (ELandeRd*)pContext;
	TCHAR					szText[1024]	= {0};

	if (!::IsWindow (pThis->m_StatusListCtrl.m_hWnd))
	{	return;
	}

	switch (Type)
	{
	case ERdFtpServer::TYPE_CONNECT:
		{
		}
		break;

	case ERdFtpServer::TYPE_DISCONNECT:
		{
		}
		break;

	case ERdFtpServer::TYPE_FILE_CREATE_SUCCESS:
		{
			pRdData->m_ListIndex = pThis->m_StatusListCtrl.InsertItem (LVIF_TEXT, pThis->m_StatusListCtrl.GetItemCount (), _T(""), 0, 0, 0, 0);
			pThis->m_StatusListCtrl.SetItemText (pRdData->m_ListIndex, ELandeRd::STATUS_LIST_COLUMN_FILENAME, pRdData->m_szFileName);

			::LoadString (GetInstanceHandle (), IDS_FILE_RECEIVE_START, szText, _countof (szText));
			pThis->m_StatusListCtrl.SetItemText (pRdData->m_ListIndex, ELandeRd::STATUS_LIST_COLUMN_STATUS, szText);
		}
		break;

	case ERdFtpServer::TYPE_STATUS_ERROR:
		{
			LPTSTR		pMsgBuf;
			TCHAR		szFormat[1024] = {0};

			if (::FormatMessage (FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL
				, pRdData->m_LastError
				, MAKELANGID (LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&pMsgBuf, 0, NULL))
			{
				StringCchCopy (szText, _countof (szText), pMsgBuf);
				::LocalFree (pMsgBuf);
			}
			else
			{

				::LoadString (GetInstanceHandle (), IDS_ERROR_FORMAT, szFormat, _countof (szFormat));
				StringCchPrintf (szText, _countof (szText), szFormat, pRdData->m_LastError);
			}

			pThis->m_StatusListCtrl.SetItemText (pRdData->m_ListIndex, ELandeRd::STATUS_LIST_COLUMN_STATUS, szText);
		}
		break;

	case ERdFtpServer::TYPE_STATUS_UPDATE:
		{
			ULONG		TimeNow			= ::GetTickCount ();
			ULONG		DiffTime		= TimeNow - pRdData->m_sTime;
			ULONG		ElapsedTime		= (TimeNow - pRdData->m_StartTime) / 1000;
			double		Percent			= 0;
			ULONG		BytePerMilliSec	= 0;
			ULONG		RemainTime		= 0;
			ULONG		WriteLength		= 0;
			ULONG		FileLength		= 0;

			if (pRdData->m_FileLength < pRdData->m_WriteLength)//݂
			{	
				pRdData->m_FileLength = pRdData->m_WriteLength;
			}
			
			WriteLength		= (ULONG)(pRdData->m_WriteLength / (1024 * 1024));
			FileLength		= (ULONG)(pRdData->m_FileLength / (1024 * 1024));
			Percent			= (double)WriteLength / (double)FileLength;
			BytePerMilliSec	= (ULONG)((pRdData->m_WriteLength - pRdData->m_PrevWriteLength) / DiffTime);


			StringCchPrintf (szText, _countof (szText), _T("%u/%u"), WriteLength, FileLength);
			pThis->m_StatusListCtrl.SetItemText (pRdData->m_ListIndex, ELandeRd::STATUS_LIST_COLUMN_FILE_LENGTH, szText);

			StringCchPrintf (szText, _countof (szText), _T("%u:%02u"), ElapsedTime / 60, ElapsedTime % 60);
			pThis->m_StatusListCtrl.SetItemText (pRdData->m_ListIndex, ELandeRd::STATUS_LIST_COLUMN_ELAPSED_TIME, szText);

			StringCchPrintf (szText, _countof (szText), _T("%2.2lf"), Percent * 100);
			pThis->m_StatusListCtrl.SetItemText (pRdData->m_ListIndex, ELandeRd::STATUS_LIST_COLUMN_ELAPSED_PER, szText);

			StringCchPrintf (szText, _countof (szText), _T("%u"), (BytePerMilliSec * 1000) / 1024);
			pThis->m_StatusListCtrl.SetItemText (pRdData->m_ListIndex, ELandeRd::STATUS_LIST_COLUMN_RECEIVE_RATE, szText);

			if (BytePerMilliSec == 0)
			{
				StringCchPrintf (szText, _countof (szText), _T("--:--"));
			}
			else
			{
				RemainTime		= (ULONG)((pRdData->m_FileLength - pRdData->m_WriteLength) / (BytePerMilliSec * 1000));//*1000 = ms to sec
				StringCchPrintf (szText, _countof (szText), _T("%u:%02u"), RemainTime / 60, RemainTime % 60);
			}
			pThis->m_StatusListCtrl.SetItemText (pRdData->m_ListIndex, ELandeRd::STATUS_LIST_COLUMN_REMAIN_TIME, szText);


			pRdData->m_PrevWriteLength = pRdData->m_WriteLength;
			pRdData->m_sTime = TimeNow;
		}
		break;

	case ERdFtpServer::TYPE_RECEIVE_COMPLETE:
		{
			::LoadString (GetInstanceHandle (), IDS_FILE_RECEIVE_END, szText, _countof (szText));
			pThis->m_StatusListCtrl.SetItemText (pRdData->m_ListIndex, ELandeRd::STATUS_LIST_COLUMN_STATUS, szText);

		}
		break;


	default:
		{
			ASSERT (FALSE);
		}
		break;
	}
}

