/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#pragma once


class EListCtrl : public EWindow
{
public:
	EListCtrl(void);
	virtual ~EListCtrl(void);

	int InsertColumn (int Col, const LVCOLUMN* pLvColumn);
	int InsertColumn (int Col, LPCTSTR pszColumnText, int Format = LVCFMT_LEFT, int Width = -1);
	BOOL DeleteColumn(int Col);

	int InsertItem(UINT Mask, int Item, LPCTSTR pszItem, UINT State, UINT StateMask, int Image, LPARAM lParam);
	int InsertItem(LVITEM* pLvItem);

	BOOL DeleteItem (int Item);
	BOOL DeleteAllItems ();

	int GetItemCount() const;
	BOOL GetItem(LVITEM* pLvItem) const;
	BOOL SetItem(const LVITEM* pLvItem);
	

	VOID SetItemText(INT Item, INT Column, LPCTSTR pszText);
	VOID GetItemText(INT Item, INT Column, LPTSTR pszText, INT cchTextMax);

	BOOL EnsureVisible(int Item, BOOL bPartialOK);
	BOOL RedrawItems(int First, int Last);


public:
	virtual BOOL	CreateEx (DWORD dwExStyle, LPCTSTR lpClassName, LPCTSTR lpWindowName, DWORD dwStyle, int x, int y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu);
	virtual	BOOL	Create (ULONG ExStyle, ULONG Style, int x, int y, int Width, int Height, HWND hWndParent, UINT_PTR Id);
	virtual	BOOL	OnDrawItemRefrection (WPARAM CtrlId,  DRAWITEMSTRUCT* pDrawItemStruct);

private:
	virtual	BOOL OnCreate (CREATESTRUCT* pStruct);
	virtual	VOID OnDestroy ();


public:
	INT			m_SelectedColumn;

	enum 
	{
		LISTCTRL_MAX_TEXT_SIZE	= (32 * 1024),
	};
};
