/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "StdAfx.h"
#include "ENetBiosNameService.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

ENetBiosNameService::ENetBiosNameService(void)
{
}

ENetBiosNameService::~ENetBiosNameService(void)
{
}

BOOL ENetBiosNameService::IsQuestion (USHORT Type)
{
	if (m_Q == 0)
	{	return FALSE;
	}

	return (m_Type == Type);
}

BOOL ENetBiosNameService::IsAnswer (USHORT Type)
{
	if (m_A == 0)
	{	return FALSE;
	}

	return (m_Type == Type);
}

PCHAR ENetBiosNameService::GetName (LPSTR pszName, size_t BufferLength)
{
	return DecodeString ((PCHAR)m_Name, m_NameLength, pszName, BufferLength);
}

VOID ENetBiosNameService::SetName (LPCSTR pszName)
{
	CHAR szString[16] = {0};
	size_t Length = 0;

	StringCchCopyNA (szString, _countof (szString), pszName, _countof (szString));
	
	if (FAILED (StringCchLengthA (szString, _countof (szString), &Length)))
	{	
		return;
	}

	while (Length < 15)
	{
		StringCchCatA (szString, _countof (szString), " ");
		Length++;
	}

	EncodeString (szString, sizeof (szString), m_Name, sizeof (m_Name));
}


PCHAR ENetBiosNameService::EncodeString (LPCSTR pszInput, size_t InputLen, LPSTR pszOutput, size_t OutputLen)
{
	UCHAR Data;
 	ULONG	BufferIndex = 0;

	::ZeroMemory (pszOutput, OutputLen);

	for(ULONG n = 0; n < InputLen; n++)
	{
		Data = (UCHAR)pszInput[n];

		pszOutput[BufferIndex++] = (CHAR)(((Data >> 4) & 0xf) + 0x41);
		if (BufferIndex > OutputLen)
		{	ASSERT (FALSE);
			break;
		}
		pszOutput[BufferIndex++] = (CHAR)(((Data >> 0) & 0xf) + 0x41);
		if (BufferIndex > OutputLen)
		{	ASSERT (FALSE);
			break;
		}
	}
	
	return pszOutput;
}


PCHAR ENetBiosNameService::DecodeString (LPCSTR pszInput, size_t InputLen, LPSTR pszOutput, size_t OutputLen)
{
	ULONG	BufferIndex = 0;

	::ZeroMemory (pszOutput, OutputLen);

	for(ULONG n = 0; (n < InputLen) && (OutputLen > 0); n += 2)
	{
		pszOutput[BufferIndex++] = ((pszInput[n] - 0x41) << 4) | ((pszInput[n + 1] - 0x41) & 0xf);
		if (BufferIndex > OutputLen)
		{	ASSERT (FALSE);
			break;
		}
	}

	return pszOutput;
}




