/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "StdAfx.h"
#include "ENetwork.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



EIpHeader::EIpHeader(void)
{
}

EIpHeader::~EIpHeader(void)
{
}

VOID EIpHeader::BuildChecksum ()
{
	ULONG			Sum			= 0;
	ULONG			Length		= 20;
	PUSHORT			pBuffer		= (PUSHORT)this;

	m_Checksum = 0;

	while (Length  > 1) 
	{
		Sum	+= *pBuffer++;
		Length	-= sizeof (USHORT);
	}
	
	if (Length)
	{	Sum += *(UCHAR*)pBuffer;
	}
	
	Sum = (Sum >> 16) + (Sum & 0xffff);
	Sum += (Sum >>16);

	m_Checksum = (USHORT)(~Sum & 0xFFFF);
}


EUdpHeader::EUdpHeader(void)
{
}

EUdpHeader::~EUdpHeader(void)
{
}

VOID EUdpHeader::BuildChecksum (ULONG SrcAddress, ULONG DstAddress)
{
	ULONG			Sum			= 0;
	ULONG			Length		= 0;
	PUSHORT			pBuffer		= (PUSHORT)this;
	USHORT			UdpexHeader[6];

	*((PULONG)&UdpexHeader[0]) = SrcAddress;
	*((PULONG)&UdpexHeader[2]) = DstAddress;
	UdpexHeader[4] = 0x1100;		//vgR UDP / pfBO
	UdpexHeader[5] = m_Length;


	USHORT OldSum = m_Checksum;

	m_Checksum = 0;

	for (int i=0;i<_countof (UdpexHeader);i++)
	{
		Sum	+= UdpexHeader[i];
	}

	Length = ntohs (m_Length);

	while (Length  > 1) 
	{
		Sum	+= *pBuffer++;
		Length	-= sizeof (USHORT);
	}
	
	if (Length)
	{	Sum += *(UCHAR*)pBuffer;
	}
	
	Sum = (Sum >> 16) + (Sum & 0xffff);
	Sum += (Sum >>16);

	m_Checksum = (USHORT)(~Sum & 0xFFFF);
}