/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#pragma once

#include <winsock2.h>
#include <IphlpApi.h>

#pragma comment (lib, "ws2_32.lib")
#pragma comment (lib, "iphlpApi.lib")

#include "EWinPcap.h"
#include "EFtpServer.h"

#pragma pack (push, 1)

class EEthernet
{
public:
	UCHAR		m_pDstMac[6];
	UCHAR		m_pSrcMac[6];
	USHORT		m_Type;
};

class EIpHeader
{
public:
	EIpHeader(void);
	~EIpHeader(void);

	VOID BuildChecksum ();

public:
	UCHAR		m_VIHL;			// Version and IHL
	UCHAR		m_TOS;			// Type Of Service
	SHORT		m_TotLen;		// Total Length
	SHORT		m_ID;			// Identification
	SHORT		m_FlagOff;		// Flags and Fragment Offset
	UCHAR		m_TTL;			// Time To Live
	UCHAR		m_Protocol;		// Protocol
	USHORT		m_Checksum;		// Checksum
	IN_ADDR		m_Src;			// Internet Address - Source
	IN_ADDR		m_Dest;			// Internet Address - Destination
};




class EUdpHeader
{
public:
	EUdpHeader(void);
	~EUdpHeader(void);

	VOID BuildChecksum (ULONG SrcAddress, ULONG DstAddress);

public:
	USHORT	m_SrcPort;
	USHORT	m_DstPort;
	USHORT	m_Length;
	USHORT	m_Checksum;
};

#pragma pack (pop)
