/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#pragma once

typedef VOID (CALLBACK*  ERDFTPSERVER_CALLBACK)(ULONG Type, PVOID pData, PVOID pContext);

class ERdFtpServer : public EFtpServer
{
public:
	class ERdData
	{
	public:
		ERdData ()
		{
			::ZeroMemory (&m_SocketAddress, sizeof (m_SocketAddress));
			::ZeroMemory (&m_szFileName, sizeof (m_szFileName));
			m_FileLength = 0;
			m_WriteLength = 0;
			m_PrevWriteLength = 0;
			m_LastError = 0;
			m_ListIndex = 0;
			m_StartTime = 0;
			m_sTime = 0;
		}

		SOCKADDR_IN		m_SocketAddress;
		ULONGLONG		m_FileLength;
		ULONGLONG		m_WriteLength;
		ULONGLONG		m_PrevWriteLength;
		ULONG			m_LastError;
		INT				m_ListIndex;
		TCHAR			m_szFileName[MAX_PATH];
		ULONG			m_StartTime;
		ULONG			m_sTime;

	};

public:
	ERdFtpServer(void);
	~ERdFtpServer(void);

	VOID	OnConnect				(EFtpClientCfg* pCfg, SOCKADDR_IN* pAddr);
	VOID	OnDisconnect			(EFtpClientCfg* pCfg, SOCKADDR_IN* pAddr);
	VOID	ProcessRETR				(EFtpClientCfg* pCfg, LPCSTR pszCommand, LPCSTR pszArguments);
	VOID	ProcessSTOR				(EFtpClientCfg* pCfg, LPCSTR pszCommand, LPCSTR pszArguments);

	VOID	DubbingInfoXmlSTOR		(EFtpClientCfg* pCfg);
	VOID	StatusXmlRETR			(EFtpClientCfg* pCfg);
	VOID	DubbingStatusXmlSTOR	(EFtpClientCfg* pCfg);
	VOID	DubbingDatSTOR			(EFtpClientCfg* pCfg);
	VOID	DubbingCommandXmlSTOR	(EFtpClientCfg* pCfg);

	VOID	SetSaveFolder			(LPCTSTR pszFolder);
	LPCTSTR	GetSaveFolder			();
	VOID	CreateDirectory			(LPCTSTR pszFolder);

	VOID	SetCallBack				(ERDFTPSERVER_CALLBACK pCallback, PVOID pContext);
	VOID	Callback				(ULONG Type, ERdData* pData);

public:
	TCHAR		m_szSaveFolder[MAX_PATH];
	BOOL		m_bAddTimeDate;
	BOOL		m_bMakeInfoTxt;

	ERDFTPSERVER_CALLBACK	m_pCallback;
	PVOID					m_pCallbackContext;

	enum _CALLBACK_TYPE
	{
		TYPE_CONNECT,
		TYPE_DISCONNECT,

		TYPE_FILE_CREATE_SUCCESS,
		TYPE_STATUS_ERROR,
		TYPE_STATUS_UPDATE,

		TYPE_RECEIVE_COMPLETE,
	};
};
