/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "StdAfx.h"
#include "ERdWinPcap.h"
#include "ENetBiosNameService.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


ERdWinPcap::ERdWinPcap (void)
{
	::ZeroMemory (m_szName, sizeof (m_szName));
}

ERdWinPcap::~ERdWinPcap (void)
{
}

VOID ERdWinPcap::SetName (LPCSTR pszName)
{
	StringCchCopyA (m_szName, _countof (m_szName), pszName);
}

LPCSTR ERdWinPcap::GetName ()
{
	return m_szName;
}

VOID ERdWinPcap::OnReceive (const UCHAR* pBuffer, ULONG Length, CThread* pThread)
{
	ENetBiosNameService*	pNetBios		= (ENetBiosNameService*)pBuffer;
	ENetBiosNameService		NetBios;
	ULONG					Address			= 0;
	CHAR					szError[PCAP_ERRBUF_SIZE] = {0};
	CPcapInterface*			pDevList		= NULL;
	CPcapInterface*			pDevListTmp		= NULL;
	CHAR					szName[128]		= {0};
	ERdWinPcap*				pThis			= (ERdWinPcap*)pThread->m_pWinPcap;

	do
	{
		if (pNetBios->m_Ethernet.m_Type != 0x0008)
		{	break;
		}
		if (pNetBios->m_IpHeader.m_Protocol != 0x11)
		{	break;
		}
		if (pNetBios->m_UdpHeader.m_DstPort != 0x8900)
		{	break;
		}
		if (!pNetBios->IsQuestion (0x2000))
		{	break;
		}

		pNetBios->GetName (szName, sizeof (szName));
		if ((szName[0] != 'G') || (szName[1] != 'R') || (szName[2] != '-'))
		{	break;
		}

		if (m_szName[0] == 0)
		{	break;
		}


#if (1)
		// --> IPAhXςƂ̑Ή̂ߍĎ擾
		if (pcap_findalldevs (&pDevList, szError) == -1)
		{	break;
		}

		pDevListTmp = pDevList;

		while (pDevListTmp)
		{
			if (strcmp (pDevListTmp->m_pszDeviceName, pThread->m_pPcapInterface->m_pszDeviceName) == 0)
			{
				CPcapAddress* pAddress = pDevListTmp->m_pAddresses;
				while (pAddress)
				{
					//DBG_MSG(("m_Family=%02X, %08X\n", pAddress->m_pAddress->m_Family, ((PSOCKADDR_IN)pAddress->m_pAddress)->sin_addr.S_un.S_addr ));
					
					if (pAddress->m_pAddress->m_Family == AF_INET)
					{	
						Address = ((PSOCKADDR_IN)pAddress->m_pAddress)->sin_addr.S_un.S_addr;
						break;
					}
					pAddress = pAddress->m_pNext;
				}
				break;
			}

			pDevListTmp = pDevListTmp->m_pNext;
		}

		pcap_freealldevs (pDevList);
		// <-- IPAhXςƂ̑Ή̂ߍĎ擾
#endif

		if (Address == 0)
		{	break;
		}

		if (Address == pNetBios->m_IpHeader.m_Src.S_un.S_addr)
		{	break;
		}


		memcpy (&NetBios.m_Ethernet.m_pSrcMac, pThread->m_pMacAddress, sizeof (NetBios.m_Ethernet.m_pSrcMac));
		memcpy (&NetBios.m_Ethernet.m_pDstMac, pNetBios->m_Ethernet.m_pSrcMac, sizeof (NetBios.m_Ethernet.m_pDstMac));

		NetBios.m_Ethernet.m_Type = 0x0008;//IP

		NetBios.m_IpHeader.m_VIHL				= 0x45;
		NetBios.m_IpHeader.m_TOS				= 0x00;
		NetBios.m_IpHeader.m_TotLen				= htons (20 + 8 + 62);//ip=20 + udp=8 + netbios=62
		NetBios.m_IpHeader.m_ID					= 0;
		NetBios.m_IpHeader.m_FlagOff			= 0;
		NetBios.m_IpHeader.m_TTL				= 128;
		NetBios.m_IpHeader.m_Protocol			= 0x11;
		NetBios.m_IpHeader.m_Checksum			= 0;
		NetBios.m_IpHeader.m_Src.S_un.S_addr	= Address;
		NetBios.m_IpHeader.m_Dest				= pNetBios->m_IpHeader.m_Src;

		NetBios.m_UdpHeader.m_SrcPort			= htons (137);
		NetBios.m_UdpHeader.m_DstPort			= htons (137);
		NetBios.m_UdpHeader.m_Length			= htons (70);
		NetBios.m_UdpHeader.m_Checksum			= 0;

		NetBios.m_ID			= pNetBios->m_ID & 0xFF00 | 0x01;//0x01=HDD, 0x02=DVD, 0x04=HDD2, 0x08=#4, 0x10=#5, 0x20=#6, 0x40=#7, 0x80=#8
		NetBios.m_Opecode		= 0x0085;
		NetBios.m_Q				= 0;
		NetBios.m_A				= 0x100;
		NetBios.m_Keni			= 0;
		NetBios.m_Add			= 0;
		NetBios.m_NameLength	= 32;
		NetBios.m_NameEnd		= 0;
		NetBios.m_Type			= 0x2000;
		NetBios.m_Class			= 0x0100;
		NetBios.m_Ttl			= 0;
		NetBios.m_Length		= 0x0600;
		NetBios.m_Flags			= 0;
		NetBios.m_SrcAddress	= Address;
		NetBios.SetName (pThis->m_szName);
		
		NetBios.m_IpHeader.BuildChecksum ();
		NetBios.m_UdpHeader.BuildChecksum (NetBios.m_IpHeader.m_Src.S_un.S_addr, NetBios.m_IpHeader.m_Dest.S_un.S_addr);

 		pcap_sendpacket (pThread->m_hDevice, (PUCHAR)&NetBios, sizeof (NetBios));
	}
	while (0);
}
