/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "EUtility.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


BOOL EUtility::GetMyDir (LPTSTR pszDir, INT Cch)
{
	TCHAR		szIniFile[MAX_PATH] = {0};
	size_t		Length;

	::ZeroMemory (pszDir, sizeof (TCHAR) * Cch);

	if (::GetModuleFileName (NULL, pszDir, Cch) == 0)
	{	return FALSE;
	}
	
	if (StringCchLength (pszDir, Cch, &Length) != S_OK)
	{	return FALSE;
	}
	
	while (Length)
	{
		Length--;
		if (pszDir[Length] == '\\')
		{	pszDir[Length+1] = 0;
			return TRUE;
		}
	}

	return FALSE;
}


LPCTSTR EUtility::LoadString (UINT nResId, LPTSTR pszText, INT Cch)
{
	::ZeroMemory (pszText, sizeof (TCHAR) * Cch);

	::LoadString (GetInstanceHandle (), nResId, pszText, Cch);

	return pszText;
}

//-------------------------------------------------------------------------------------------------
//	tH_I
//-------------------------------------------------------------------------------------------------
int EUtility::SelectDirectoryCallBackProc (HWND hWnd, UINT uiMsg, LPARAM lParam, LPARAM lpData)
{
	if(uiMsg == BFFM_INITIALIZED)
	{
		if( lpData != NULL)
		{
			::SendMessage (hWnd, BFFM_SETSELECTION, TRUE, lpData );
		}

		::SetWindowLong (hWnd, GWL_EXSTYLE, ::GetWindowLong (hWnd, GWL_EXSTYLE) & ~WS_EX_CONTEXTHELP);
	}
	return(0);
}

BOOL EUtility::SelectDirectory (HWND hWnd, LPCTSTR pszTitle, LPCTSTR pszDefDirectory, LPTSTR pszDirectory, INT CchDirectory) 
{
	TCHAR			szTargetDrive[MAX_PATH] = {0};
	BROWSEINFO		BrowsInfo				= {0};
	LPITEMIDLIST	pItemIdListRoot			= NULL;
	LPITEMIDLIST	pItemIdList				= NULL;
	LPMALLOC		pAlloc					= NULL;
	BOOL			Result					= FALSE;
	//LPITEMIDLIST	pidl = NULL;

	do
	{
		if (::SHGetSpecialFolderLocation (hWnd, CSIDL_DESKTOP  ,&pItemIdListRoot) != S_OK)
		{	break;
		}

		//if (FAILED (::SHParseDisplayName (pszDefDirectory, NULL, &pidl, 0, NULL)))
		//{int x=0;
		//}
  
		BrowsInfo.hwndOwner			= hWnd;
		BrowsInfo.pidlRoot			= NULL;
		BrowsInfo.pszDisplayName	= NULL;
		BrowsInfo.lpszTitle			= pszTitle;
		BrowsInfo.ulFlags			= BIF_RETURNONLYFSDIRS | BIF_USENEWUI;
		BrowsInfo.lpfn				= SelectDirectoryCallBackProc;
		BrowsInfo.lParam			= (LPARAM)pszDefDirectory;
		BrowsInfo.iImage			= 0;

		//tH_IʋN
		pItemIdList = ::SHBrowseForFolder (&BrowsInfo);

		if (pItemIdList == NULL)
		{	break;
		}

		if (::SHGetPathFromIDList (pItemIdList, szTargetDrive))
		{
			StringCchCopy (pszDirectory, CchDirectory, szTargetDrive);
			Result = TRUE;
		}

	}
	while (0);

	if (pItemIdList != NULL)
	{
		CoTaskMemFree (pItemIdList);
	}

	if (pItemIdListRoot != NULL)
	{
		CoTaskMemFree (pItemIdListRoot);
	}

	return Result;
}

INT EUtility::MsgBox (HWND hWnd, UINT nTitle, UINT nMsg, UINT uType)
{
	TCHAR szTitle[1024] = {0};
	TCHAR szMsg[1024] = {0};

	::LoadString (GetInstanceHandle (), nTitle, szTitle, _countof (szTitle));
	::LoadString (GetInstanceHandle (), nMsg, szMsg, _countof (szMsg));

	return ::MessageBox (hWnd, szMsg, szTitle, uType);
}
