/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "StdAfx.h"
#include "EWinMain.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif




EWinMain::EWinMain(void)
{
	m_hAccelTable	= NULL;
	m_hInstance		= NULL;
	m_lpCmdLine		= NULL;
}

EWinMain::~EWinMain(void)
{
}

int EWinMain::WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	MSG Msg;
	WNDCLASSEX WcEx;

	m_hInstance	= hInstance;
	m_lpCmdLine	= lpCmdLine;


	if (!OnInitiInstance ())
	{	return FALSE;
	}

	StringCchPrintf (m_szWindowClass, _countof (m_szWindowClass), _T("EWinMain"));


	WcEx.cbSize			= sizeof(WNDCLASSEX);
	WcEx.style			= CS_HREDRAW | CS_VREDRAW;
	WcEx.lpfnWndProc	= WndProc;
	WcEx.cbClsExtra		= 0;
	WcEx.cbWndExtra		= 0;
	WcEx.hInstance		= m_hInstance;
	WcEx.hIcon			= NULL;
	WcEx.hCursor		= ::LoadCursor (NULL, IDC_ARROW);
	WcEx.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	WcEx.lpszMenuName	= NULL;
	WcEx.lpszClassName	= m_szWindowClass;
	WcEx.hIconSm		= NULL;

	if (!OnPreRegisterClass (&WcEx))
	{	return FALSE;
	}

	if (!RegisterClassEx(&WcEx))
	{
		if (::GetLastError () != ERROR_CLASS_ALREADY_EXISTS)
		{
			return FALSE;
		}
	}




	if (!CreateEx (0, m_szWindowClass, m_szTitle, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL))
	{	return FALSE;
	}

	::ShowWindow (m_hWnd, nCmdShow);
	::UpdateWindow (m_hWnd);

	// Main message loop:
	while (1)
	{
		INT i = ::GetMessage (&Msg, NULL, 0, 0);
		if ((i== -1) || (i==0))
		{	break;
		}

		if (!::TranslateAccelerator (Msg.hwnd, m_hAccelTable, &Msg))
		{
			::TranslateMessage (&Msg);
			::DispatchMessage (&Msg);
		}
	}

	OnExitInstance ();

	return (int) Msg.wParam;
}

BOOL EWinMain::OnInitiInstance ()
{

	return TRUE;
}

VOID EWinMain::OnExitInstance ()
{
}

BOOL EWinMain::OnPreRegisterClass (WNDCLASSEX* pWndClass)
{
	return TRUE;
}

VOID EWinMain::OnNcDestroy ()
{
	::PostQuitMessage (0);
}
