/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#pragma once

class EWinPcap
{
public:

	class CSockAddress
	{
	public:
        USHORT		m_Family;
        CHAR		m_Data[14];
	};

	class CPcapAddress
	{
	public:
		CPcapAddress*	m_pNext;
		CSockAddress*	m_pAddress;
		CSockAddress*	m_pNetMask;
		CSockAddress*	m_pBroadAddress;
		CSockAddress*	m_pDstAddress;
	};


	class CPcapInterface
	{
	public:
		CPcapInterface*		m_pNext;
		LPCSTR				m_pszDeviceName;
		LPCSTR				m_pszDescription;
		CPcapAddress*		m_pAddresses;
		ULONG				m_Flags;
	};

	class CPcapPacketHeader
	{
	public:
		struct timeval	m_TimeStamp;
		ULONG	m_CaptureLength;
		ULONG	m_Length;
	};

	class CBpfInsn
	{
	public:
		USHORT	m_Code;
		UCHAR 	m_Jt;
		UCHAR 	m_Jf;
		ULONG	m_K;
	};

	class CBpfProgram
	{
	public:
		CBpfProgram ()
		{
			m_Length = 0;
			m_pBpfInsns = NULL;
		}
		UINT		m_Length;
		CBpfInsn*	m_pBpfInsns;
	};

	enum
	{
		PCAP_ERRBUF_SIZE	= 512,
	};


	class CThread
	{
	public:
		CThread ()
		{
			m_pWinPcap			= NULL;
			m_pPcapInterface	= NULL;
			m_hDevice			= NULL;
			m_hThread			= NULL;
			m_pRunning			= NULL;
			::ZeroMemory (m_pMacAddress, sizeof (m_pMacAddress));
		}
	public:
		EWinPcap*		m_pWinPcap;
		CPcapInterface*	m_pPcapInterface;
		HANDLE			m_hDevice;
		HANDLE			m_hThread;
		PLONG			m_pRunning;
		UCHAR			m_pMacAddress[6];
	};


public:
	EWinPcap(void);
	~EWinPcap(void);

	BOOL		StartCapture		(LPCSTR pszFilter);
	VOID		StopCapture			();
	BOOL		IsRunning			();

	LPCSTR		GetLastErrorString ();

	virtual	VOID	OnReceive	(const UCHAR* pBuffer, ULONG Length, CThread* pThread);

private:
	BOOL		SetFilter			(HANDLE hDevice, LPCSTR pszFilter);
	BOOL		FindMacAddress		(LPCSTR pszDevice, PUCHAR pMacAddress, size_t Size);

static ULONG WINAPI CaptureThread (PVOID pVoid);

public:
	HMODULE				m_hWPcapDll;
	HANDLE				m_hStop;
	CHAR				m_szError[PCAP_ERRBUF_SIZE];
	EList<CThread*>		m_ThreadList;
	CPcapInterface*		m_DevList;
	LONG				m_nThreadRunning;


	INT		(*pcap_findalldevs)	(CPcapInterface **ppIf, CHAR *err);
	VOID	(*pcap_freealldevs)	(CPcapInterface *pIf);
	HANDLE	(*pcap_open_live)	(const char *pszDevName, int WholePacketSize, int Mode, int Timeout, char *err);
	void	(*pcap_close)		(HANDLE hDevice);
	int 	(*pcap_next_ex)		(HANDLE hDevice, CPcapPacketHeader **ppHeader, const u_char **ppData);
	int		(*pcap_setfilter)	(HANDLE hDevice, CBpfProgram* pBpf);
	int		(*pcap_compile)		(HANDLE hDevice, CBpfProgram* pBpf, LPCSTR pszFilter, int optimize, ULONG netmask);
	void	(*pcap_freecode)	(CBpfProgram* pBpf);
	int		(*pcap_sendpacket)	(HANDLE hDevice, PUCHAR pBuffer, INT Ssize);
 
 


};
