/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#pragma once

#define WM_REFLECT_BASE 0xBC00

class EWindow
{
public:
	EWindow(void);
	virtual ~EWindow(void);

	VOID Initialize ();
	VOID DeInitialize ();

protected:
	virtual	BOOL	OnCreate (CREATESTRUCT* pStruct);
	virtual	VOID	OnDestroy ();
	virtual	VOID	OnNcDestroy ();
	virtual	VOID	OnSize (UINT nType, int cx, int cy);
	virtual	BOOL	OnPaint ();
	virtual	BOOL	OnDrawItemRefrection (WPARAM CtrlId,  DRAWITEMSTRUCT* pDrawItemStruct);
	virtual	BOOL	OnNotify (WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual	BOOL	OnNotifyRefrection (WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual BOOL	OnCommand (WPARAM wParam, LPARAM lParam);
	virtual	BOOL	OnCommandRefrection (WPARAM wParam, LPARAM lParam);
	virtual BOOL	OnWndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult);

public:
	virtual BOOL	CreateEx	(DWORD dwExStyle, LPCTSTR lpClassName, LPCTSTR lpWindowName, DWORD dwStyle, int x, int y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu);
	LRESULT		DefWndProc		(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

	BOOL		HookWindowCreate	(EWindow* pWindow);
	BOOL		UnHookWindowCreate	(EWindow* pWindow);

public:
static LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static LRESULT CALLBACK CBTProc (int Code, WPARAM wParam, LPARAM lParam);


public:
	HWND	m_hWnd;

	LRESULT (CALLBACK* m_pfnDefWndProc)(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

public:
	static EList<EWindow*>		s_HookWindowList;
	static HHOOK				s_hHook;
	static LONG					s_HookCount;
	static UINT					WM_DELETE_THIS;
};
